<p>
    {{> theorie }}
    Unter Normalisierung eines relationalen Datenschemas versteht man die Aufteilung von Attributen in
    mehrere Relationen gemäß den <span class="bold">Normalisierungsregeln</span>. Ziel ist ein
    Datenschema in einer Form, die
<ul class="ovk-bullet-list">
    <li>Datenredundanzen vermeidet</li>
    <li>logische Widersprüche in der Datenbasis verhindert</li>
    <li>höchstmögliche Flexibilität und einen schnellen Zugriff gewährleistet</li>
</ul>
</p>
<p>
    Die Aufteilung des Datenbankschemas muss dabei <span class="bold">verlustfrei</span> sein, d.h. ein
    späteres Zusammensetzen der geteilten Tabelle über Fremd- und Primärschlüssel muss wieder zur
    ursprünglichen Tabelle führen, ohne dass dabei Informationen verloren gehen.
</p>
<h2>Normalformen</h2>
<p>Normalisierung beruht auf sogenannten <span class="bold">Normalformen</span>​. Folgende Normalformen
    können unterschieden werden:
</p>
<div class="nav nav-tabs" role="tab">
    <button class="nav-link active" data-bs-toggle="tab" href="#home">1. Normalform (1NF)</button>
    <button class="nav-link" data-bs-toggle="tab" href="#menu1">2. Normalform (2NF)</button>
    <button class="nav-link" data-bs-toggle="tab" href="#menu2">3. Normalform (3NF)</button>
</div>
<div class="tab-content">
    <div class="tab-pane container active" id="home">
        <p>
            Eine Relation ist in der 1. Normalform, wenn<br />
        <ul class="ovk-bullet-list">
            <li>alle Attribute nur atomare Werte enthalten<br />
                Das Attribut <code>Adresse</code> ist z.&nbsp;B kein atomares Attribut. Adressen können
                in die Attribute Straße, Hausnummer, Postleitzahl und Ort aufgeteilt werden. Das
                Attribut <code>Name</code> ist ebenso nicht atomar, denn Namen können in (erster und
                zweiter) Vorname und Nachname aufgeteilt werden.
            </li>
            <li>jede Zeile durch ein Schlüsselattribut oder eine Attributkombination eindeutig
                identifiziert ist
            </li>
        </ul>
        </p>
    </div>
    <div class="tab-pane container fade" id="menu1">
        <p>
            Eine Relation ist in der 2. Normalform, wenn
        <ul class="ovk-bullet-list">
            <li>sie in der 1. Normalform ist und</li>
            <li>Jedes Nichtschlüsselattribut von jedem Schlüsselkandidaten voll funktional abhängig
                ist.<br />
                In der Praxis bedeutet das, dass alle n:m-Beziehungen aufgelöst sind und für sie eigene
                Tabellen erstellt wurden.
            </li>
        </ul>
        </p>
    </div>
    <div class="tab-pane container fade" id="menu2">
        <p>
            Eine Relation ist in der 3. Normalform, genau dann wenn
        <ul class="ovk-bullet-list">
            <li>Sie in der 2. Normalform ist und</li>
            <li>Kein Nichtschlüsselattribut von einem Schlüsselkandidaten transitiv abhängig
                ist.<br />
                In der Praxis bedeutet das, dass alle 1:n-Beziehungen aufgelöst sein müssen. Für solche
                Beziehungen werden also u.&nbsp;U. eigene Tabellen erstellt.
            </li>
        </ul>
        </p>
    </div>
</div>
<p>
    {{> video }} Im folgenden Video wird darauf eingegangen, wann eine Normalisierung notwendig ist und
    die genannten Normalformen noch einmal genauer erklärt.<br />
    <iframe class="ovk-video"
        src="https://videocampus.sachsen.de/media/embed?key=d2e3305e6a08e24c71341a752fb11cad&width=480&height=300&autoplay=false&autolightsoff=false&loop=false&chapters=false&related=false&responsive=false&t=0"
        data-src="" class="iframeLoaded" width="480" height="300" frameborder="0"
        allowfullscreen="allowfullscreen" allowtransparency="true" scrolling="no"></iframe>
</p>
<p>
<div class="card ovk-story">
    <div class="card-header schon-gewusst-header">
        {{> info }}
        <div style="padding-top: 0.2em;">Schon gewusst?</div>
    </div>
    <div class="card-body schon-gewusst-body">
        <p>
            Es gibt insgesamt 6 Normalformen, darunter auch die <a
                href="https://de.wikipedia.org/wiki/Normalisierung_(Datenbank)#Boyce-Codd-Normalform_(BCNF)">
                Boyce-Codd-Normalform (BCNF)</a>, auf die wir jedoch in diesem Modul nicht weiter
            eingehen möchten.
        </p>
    </div>
</div>
</p>

